#!/bin/bash -x 


pushd `dirname $0` > /dev/null
SCRIPTPATH=`pwd -P`
popd > /dev/null

export top_level_dir=$1'/data-integration'
echo $top_level_dir

echo "***************************************************************************************************************************"
echo Start job for loading Schema of Stage and Star
echo "****************************************************************************************************************************"
echo
# create vertica_clusters schema
sh $top_level_dir'/kitchen.sh' -file=$2/VHIST_ETL/JOBS/vhist_main.kjb -level=Detailed > $2/VHIST_ETL/logs/jobs.txt

echo 
echo "****************************************************************************************************************************"
echo End job for loading Schema of Stage and Star, to check log $2/VHIST_ETL/logs/jobs.txt for detail logs
echo "****************************************************************************************************************************"