drop TABLE if exists  vhist.date_dim;
CREATE TABLE if not exists vhist.date_dim (
       date_key      integer not null,   
       date              date,
       weekday_num   integer,
       weekday           char(9),
       week_num       integer,
       month_num     integer,
       month               char(9),
       quarter_num    integer,
       year                   integer
);
COMMENT ON TABLE  vhist.date_dim          IS 'Date dimension table for the DC subject area';
insert into vhist.date_dim values (1);
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim;
insert into vhist.date_dim select * from  vhist.date_dim   OFFSET 157; 
drop sequence if exists date_dim_key_seq;
create sequence  date_dim_key_seq start 731947; 
update vhist.date_dim set date_key     =  cast(replace ( to_char(date(  nextval('date_dim_key_seq')  )  ),'-','')  as integer),date        =           date(  currval('date_dim_key_seq')  ),           weekday_num = dayofweek(date(  currval('date_dim_key_seq')  )),           weekday     =   to_char(date(  currval('date_dim_key_seq')  ), 'day'),           week_num    =      week(date(  currval('date_dim_key_seq')  )),    month_num   =     month(date(  currval('date_dim_key_seq')  )),    month       =   to_char(date(  currval('date_dim_key_seq')  ), 'month'),    quarter_num =   quarter(date(  currval('date_dim_key_seq')  )),    year        =      year(date(  currval('date_dim_key_seq')  ));
ALTER TABLE vhist.date_dim ADD PRIMARY KEY (date_key);
drop TABLE if exists vhist.time_dim;
CREATE TABLE if not exists vhist.time_dim (
       time_key      integer not null,   
       time_of_day   time,
       second_num    integer,
       minute_num    integer,
       hour_num      integer,
       shift_num     integer
);
COMMENT ON TABLE  vhist.time_dim          IS 'time_dim table for the DC subject area';
insert into vhist.time_dim values (1);
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim;
insert into vhist.time_dim select * from  vhist.time_dim   OFFSET 44672; 
drop sequence if exists time_dim_key_seq;
create sequence  time_dim_key_seq MINVALUE 0 START WITH 0 NO CYCLE; 
update vhist.time_dim set        time_key    =                  nextval('time_dim_key_seq'),      
 time_of_day =  to_char( floor( currval('time_dim_key_seq')/(60*60)   )||
 case when mod(floor( currval('time_dim_key_seq')/(60)      ),60)>9 then cast(mod(floor( currval('time_dim_key_seq')/(60)      ),60) as varchar) else '0'||cast(mod(floor( currval('time_dim_key_seq')/(60)      ),60)as varchar) end||case when mod(currval('time_dim_key_seq'),60)>9 then cast(mod(currval('time_dim_key_seq'),60) as varchar) else '0'||cast(mod(currval('time_dim_key_seq'),60)as varchar) end ,'00:00:09')::time  ,       second_num  =       mod(       currval('time_dim_key_seq'            ),60),       minute_num  =       mod(floor( currval('time_dim_key_seq')/(60)      ),60),       hour_num    =           floor( currval('time_dim_key_seq')/(60*60)   )    ,       shift_num   =       1 + floor( currval('time_dim_key_seq')/(60*60*8) );
ALTER TABLE vhist.time_dim ADD PRIMARY KEY (time_key);


