CREATE TABLE IF NOT EXISTS disk_storage
(
    node_name varchar(128),
    storage_path varchar(8192),
    storage_usage varchar(8192),
    rank int,
    throughput int,
    latency int,
    storage_status varchar(80),
    disk_block_size_bytes int,
    disk_space_used_blocks int,
    disk_space_used_mb int,
    disk_space_free_blocks int,
    disk_space_free_mb int,
    disk_space_free_percent varchar(80),
	batch_id integer
);



