CREATE TABLE IF NOT EXISTS nodes
(
    node_name varchar(128),
    node_id int,
    node_state varchar(128),
    node_address varchar(80),
    node_address_family varchar(10),
    export_address varchar(8192),
    export_address_family varchar(10),
    catalog_path varchar(8192),
    node_type varchar(9),
    is_ephemeral boolean,
    standing_in_for varchar(128),
    node_down_since timestamptz,
	batch_id integer
);



