drop sequence if exists batch_id_seq;
create sequence batch_id_seq    START with 1      cache 1      no cycle;
DROP TABLE IF EXISTS vhist_stage.BATCH_DIM CASCADE;
create table if not exists vhist_stage.BATCH_DIM(batch_id 	INTEGER,batch_current_ts	timestamp,script_name	varchar(30));	
insert into vhist_stage.BATCH_DIM values(0, '0001-01-01'::timestamp, 'vmon_to_stage');
DROP TABLE IF EXISTS vhist.BATCH_DIM CASCADE;
create table if not exists vhist.BATCH_DIM	(batch_id 	INTEGER,batch_current_ts	timestamp,script_name	varchar(30));	
insert into vhist.BATCH_DIM values(0, '0001-01-01'::timestamp, 'stage_to_star');
DROP TABLE IF EXISTS vhist_stage.vhist_stage_load_log CASCADE;
CREATE TABLE IF NOT EXISTS vhist_stage.vhist_stage_load_log (table_name VARCHAR(128), batch_id Integer,batch_status VARCHAR(64),batch_row_count Integer,batch_failure_reason VARCHAR(2048),table_last_insert_timestamp Timestamp,table_current_insert_timestamp Timestamp,actual_load_start_timestamp TimestampTZ,actual_load_end_timestamp TimestampTZ,actual_load_duration_in_second float);
DROP TABLE IF EXISTS vhist.vhist_load_log CASCADE;
CREATE TABLE IF NOT EXISTS vhist.vhist_load_log (table_name VARCHAR(128), batch_id Integer,batch_status VARCHAR(64),batch_row_count Integer,batch_failure_reason VARCHAR(2048),table_last_insert_timestamp Timestamp,table_current_insert_timestamp Timestamp,actual_load_start_timestamp TimestampTZ,actual_load_end_timestamp TimestampTZ,actual_load_duration_in_second float);