CREATE TABLE IF NOT EXISTS load_streams
(
    session_id varchar(128),
    transaction_id int,
    statement_id int,
    stream_name varchar(128),
    schema_name varchar(128),
    table_id int,
    table_name varchar(128),
    load_start varchar(63),
    load_duration_ms numeric(54,0),
    is_executing boolean,
    accepted_row_count int,
    rejected_row_count int,
    read_bytes int,
    input_file_size_bytes int,
    parse_complete_percent int,
    unsorted_row_count int,
    sorted_row_count int,
    sort_complete_percent int,
	batch_id integer
);



