CREATE TABLE IF NOT EXISTS query_profiles
(
    session_id varchar(128),
    transaction_id int,
    statement_id int,
    identifier varchar(128),
    node_name varchar(128),
    query varchar(64000),
    query_search_path varchar(64000),
    schema_name varchar(128),
    table_name varchar(128),
    projections_used varchar(22),
    query_duration_us numeric(36,6),
    query_start_epoch int,
    query_start varchar(63),
    query_type varchar(128),
    error_code int,
    user_name varchar(128),
    processed_row_count int,
    reserved_extra_memory int,
    is_executing boolean,
	batch_id integer
);



