CREATE TABLE IF NOT EXISTS user_sessions
(
    node_name varchar(128),
    user_name varchar(128),
    session_id varchar(128),
    transaction_id int,
    statement_id int,
    runtime_priority varchar(128),
    session_start_timestamp timestamptz,
    session_end_timestamp timestamptz,
    is_active boolean,
    client_hostname varchar(128),
    client_pid int,
    client_label varchar(64000),
    ssl_state varchar(128),
    authentication_method varchar(128),
    client_type varchar(128),
    client_version varchar(128),
    client_os varchar(128),
	batch_id integer
);



